﻿#pragma once
#include "Ammo/LMAmmoType.h"
#include "LMBulletInfo.generated.h"

USTRUCT(BlueprintType)
struct FLMBulletInfo
{
	GENERATED_BODY()

	/** The number of bullets to fire. */
	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	int BulletCount;

	/** The bullets' origins. */
	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	FVector Origin;

	/** The main direction vector. */
	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	FVector Direction;

	/** The Random bullet spread angle deviation. */
	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	float Spread;

	/** The maximum distance before the bullet reaches minimum damages. */
	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	float MaxDistance;

	/** A curve multiplicating the damage of a bullet depending on the distance of the target. */
	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	FFloatCurve Falloff;

	/** The type of bullet that was fired. */
	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	EAmmoType AmmoType;

	/** The default amount of damage to apply per bullet. */
	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	float Damage;
};
